Attribute VB_Name = "BinaryUtil"
Public Const INVALID_VERSION_PACKET As Integer = 0
Public Enum e_BinaryData
        DefineByte = 1                          '  8 Bits Data
        DefineWord = 2                          ' 16 Bits Data
        DefineDoubleWord = 4                    ' 32 Bits Data
        DefineQuadWord = 8                      ' 64 Bits Data
    End Enum
Function CreateVersionPacket(HashCmd As String, mpqname As String) As String
    Dim version As Long
    Dim Checksum As Long
    Dim ExeInfo As String
    Dim Result As Long
    Dim VersionByte As Long
    Dim Path As String
    Dim GameExe As String
    Path = getGamePath(msProduct)
    VersionByte = getProductHash(msProduct)
    GameExe = getGameExe(msProduct)
    ExeInfo = Space(256)
    If (msProduct = "D2DV") Or (msProduct = "D2XP") Then
        Result = CheckRevision(Path & GameExe, Path & "bnclient.dll", Path & "d2client.dll", HashCmd, version, Checksum, ExeInfo, mpqname)
    Else
        Result = CheckRevision(Path & GameExe, Path & "storm.dll", Path & "battle.snp", HashCmd, version, Checksum, ExeInfo, mpqname)
    End If
    'R = CheckRevision(Path & GameExe, Path & "storm.dll", Path & "battle.snp", HashCmd, version, Checksum, ExeInfo, mpqname)
    NullTruncString ExeInfo
    If Result Then
        CreateVersionPacket = "68XI" & ReverseString(msProduct) & MKL(VersionByte) & MKL(version) & MKL(Checksum) & ExeInfo & Chr(0)
    Else
        CreateVersionPacket = CStr(INVALID_VERSION_PACKET)
    End If
End Function

Function MKL(value As Long) As String
    Dim Result As String * 4
    CopyMemory ByVal Result, value, 4
    MKL = Result
End Function

Function MKI(value As Integer) As String
    Dim Result As String * 2
    CopyMemory ByVal Result, value, 2
    MKI = Result
End Function

Function CVL(x As String) As Long
    If Len(x) < 4 Then
        MsgBox "CVL(): String too short"
        Stop
    End If
    CopyMemory CVL, ByVal x, 4
End Function

Function CVI(x As String) As Integer
    If Len(x) < 2 Then
        MsgBox "CVI(): String too short"
        Stop
    End If
    CopyMemory CVI, ByVal x, 2
End Function

Public Sub NullTruncString(ByRef text As String)
    Dim i As Integer
    i = InStr(text, Chr(0))
    If i = 0 Then Exit Sub
    text = Left(text, i - 1)
End Sub


Public Sub DecodeCDKey(ByVal sCDKey As String, ByRef dProductId As Double, ByRef dValue1 As Double, ByRef dValue2 As Double)

    sCDKey = UCase(Replace(Replace(sCDKey, "-", ""), " ", ""))
    'MsgBox sCDKey
    If Len(sCDKey) = 13 Then
        sCDKey = DecodeStarcraftKey(sCDKey)
    ElseIf Len(sCDKey) = 16 Then
        sCDKey = DecodeD2Key(sCDKey)
    Else
       Exit Sub
    End If
    
    dProductId = Val("&H" & Left$(sCDKey, 2))
    
    If Len(sCDKey) = 13 Then
        dValue1 = Val(Mid$(sCDKey, 3, 7))
        dValue2 = Val(Mid$(sCDKey, 10, 3))

    ElseIf Len(sCDKey) = 16 Then
        dValue1 = Val("&H" & Mid$(sCDKey, 3, 6))
        dValue2 = Val("&H" & Mid$(sCDKey, 9))
    End If
    
End Sub

Public Function DecodeD2Key(ByVal key As String) As String
    Dim R As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, _
    c As Byte, bValid As Boolean, i As Integer, aryKey(0 To 15) As String, _
    codevalues As String
    key = UCase(key)
    codevalues = "246789BCDEFGHJKMNPRTVWXZ"
    R = 1
    keyvalue = 0
    
    For i = 1 To 16
    
        aryKey(i - 1) = Mid$(key, i, 1)
        
    Next i
    
    For i = 0 To 15 Step 2
        c1 = InStr(1, codevalues, aryKey(i)) - 1
        If c1 = -1 Then c1 = &HFF
        n = c1 * 3
        c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
        If c2 = -1 Then c2 = &HFF
        n = c2 + n * 8
        
        If n >= &H100 Then
        
            n = n - &H100
            keyvalue = keyvalue Or R
            
        End If
        
        n2 = n
        n2 = RShift(n2, 4)
        aryKey(i) = GetHexValue(n2)
        aryKey(i + 1) = GetHexValue(n)
        R = LShift(R, 1)
        
cont:

    Next i
    
    v = 3
    
    For i = 0 To 15
    
        c = GetNumValue(aryKey(i))
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v And &HFF
    
    For i = 15 To 0 Step -1
    
        c = Asc(aryKey(i))
        
        If i > 8 Then
        
            n = i - 9
            
        Else
        
            n = &HF - (8 - i)
            
        End If
        
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(c)
        
    Next i
    
    v2 = &H13AC9741
    
    For i = 15 To 0 Step -1
    
        c = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(c)
        
        If Val(c) <= Asc("7") Then
        
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
            
        ElseIf Val(c) < Asc("A") Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = Chr$(c2)
            
        End If
        
    Next i
    
    DecodeD2Key = Join(aryKey, "")
    
    Erase aryKey()
    
End Function
Public Function DecodeStarcraftKey(ByVal sKey As String) As String

    Dim R As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, c As Byte, _
    bValid As Boolean, i As Integer, aryKey(0 To 12) As String
    
    For i = 1 To 13
    
        aryKey(i - 1) = Mid$(sKey, i, 1)
        
    Next i
    
    v = 3
    
    For i = 0 To 11
    
        c = aryKey(i)
        n = Val(c)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v Mod 10
    
    If hex(v) = aryKey(12) Then
    
        bValid = True
        
    End If
    
    v = 194
    
    For i = 11 To 0 Step -1
    
        If v < 7 Then GoTo continue
        c = aryKey(i)
        n = CInt(v / 12)
        n2 = v Mod 12
        v = v - 17
        c2 = aryKey(n2)
        aryKey(i) = c2
        aryKey(n2) = c
        
    Next i
    
continue:

    v2 = &H13AC9741
    
    For i = 11 To 0 Step -1
    
        c = UCase$(aryKey(i))
        aryKey(i) = c
        
        If Asc(c) <= Asc("7") Then
        
            v = v2
            c2 = v And &HFF
            c2 = c2 And 7
            c2 = c2 Xor c
            v = RShift(CLng(v), 3)
            aryKey(i) = c2
            v2 = v
            
        ElseIf Asc(c) < 65 Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor c
            aryKey(i) = c2
            
        End If
        
    Next i
    
    DecodeStarcraftKey = Join(aryKey, "")
    
    Erase aryKey()
    
End Function
Public Function RShift(ByVal pnValue As Double, ByVal pnShift As Double)
    ' Equivilant to C's Bitwise >> ope
    '     rator
    RShift = CLng(pnValue \ (2 ^ pnShift))
End Function

Public Function LShift(ByVal pnValue As Double, ByVal pnShift As Double)
    ' Equivilant to C's Bitwise << ope
    '     rator
    LShift = pnValue * (2 ^ pnShift)
End Function

Public Function rol(value As Long, shift As Byte) As Long
    rol = (LShift(value, shift)) Or (RShift(value, 32 - shift))
End Function
Public Function MAKE_CDKey(ByVal Seed As Long, ByVal myCDKey As String, ByVal CDKeyUser As String, ByVal Spawn As Boolean) As String
    Dim lngSeed As Long, lngKey As Long, lngProdID As Long, lngValue1 As Long, _
        lngValue2 As Long, dblProdID As Double, dblValue1 As Double, _
        dblValue2 As Double, dblSeed As Double, dblKey As Double, _
        botPacket As New PacketBuffer
    
    dblSeed = Val(Seed)
    dblKey = GetTickCount
    lngSeed = CLng(dblSeed)
    lngKey = CLng(dblKey)
    
    Call DecodeCDKey(myCDKey, dblProdID, dblValue1, dblValue2)
    
    lngProdID = CLng(dblProdID)
    lngValue1 = CLng(dblValue1)
    lngValue2 = CLng(dblValue2)
    
    Call ChDir(App.Path)
    Call HashCDKey(lngKey, lngSeed, lngProdID, lngValue1, lngValue2)

    With botPacket
    
        Call .InsertDWORD(IIf(Spawn, 1, 0))    ' Spawn = 1; NoSpawn = 0
        Call .InsertDWORD(Len(myCDKey))        ' CD-Key Len
        Call .InsertDWORD(CLng(dblProdID))     ' Product ID
        Call .InsertDWORD(CLng(dblValue1))     ' Value1
        Call .InsertDWORD(CLng(dblSeed))       ' Server Key
        Call .InsertDWORD(CLng(dblKey))        ' Client Key
        Call .InsertDWORD(lngKey)              ' CD-Key Hash pt1
        Call .InsertDWORD(lngSeed)             ' CD-Key Hash pt2
        Call .InsertDWORD(lngProdID)           ' CD-Key Hash pt3
        Call .InsertDWORD(lngValue1)           ' CD-Key Hash pt4
        Call .InsertDWORD(lngValue2)           ' CD-Key Hash pt5
        Call .InsertNTString(CDKeyUser)        ' CD-Key User
        MAKE_CDKey = .GetPacket(&H36)
        
    End With
    
    Set botPacket = Nothing
    
End Function


Public Function GetHexValue(ByVal v As Long) As String

    v = v And &HF
    
    If v < 10 Then
    
        GetHexValue = Chr$(v + &H30)
        
    Else
    
        GetHexValue = Chr$(v + &H37)
        
    End If
    
End Function
Function ReadMem(ByVal MemPointer As Long, _
                     SizeInBytes As e_BinaryData)
        Select Case SizeInBytes
            Case DefineByte
                Dim DB As Byte
                CopyMemory DB, ByVal MemPointer, 1
                ReadMem = DB
            Case DefineWord
                Dim DW As Integer
                CopyMemory DW, ByVal MemPointer, 2
                ReadMem = DW
            Case DefineDoubleWord
                Dim DD As Long
                CopyMemory DD, ByVal MemPointer, 4
                ReadMem = DD
            Case DefineQuadWord
                Dim DX As Double
                CopyMemory DX, ByVal MemPointer, 8
                ReadMem = DX
        End Select
    End Function
Sub WriteMem(ByVal MemPointer As Long, _
                 SizeInBytes As e_BinaryData, _
                 ByVal DataToWrite)
        CopyMemory ByVal MemPointer, VarPtr(DataToWrite), SizeInBytes
    End Sub

Public Function GetNumValue(ByVal c As String) As Long

    c = UCase(c)
    
    If IsNumeric(c) Then
    
        GetNumValue = Asc(c) - &H30
        
    Else
    
        GetNumValue = Asc(c) - &H37
        
    End If
    
End Function
