VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPointer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' Pointer class module to implement pointers'
'     into visual basic simple and easy     '

' Version: 3.0.3 (C) David Fritts

' Note #1: If you are absolutely sure your VB6 project never raises a "Subscript
' out of range" error, you can compile it into native code and enable "Remove
' Array Bounds Check" option. This should speed up this module and other
' functions and subs in this project that use arrays up to 50%.

' Note #2: I store the addresses in arrays so when the module unloads it will
' free up any memory taken. This is just in case you forget. If you want to make
' the module faster you could take out the arrays but remember to ALWAYS free up
' the memory taken.

' Note #3: GetInputState(); Will speed up any type of loop! So i decided
' use it to speed up the for/next statements. I timed the module and its
' now so fast it can't be timed in miliseconds!

Option Explicit
DefLng A-Z
'Warning: All undeclared variables will be type Long'

Public Enum PtrType
    IntPtr = 1
    LngPtr = 2
End Enum

Dim IntegerPtr() As Long: Dim LongPtr() As Long

Private Declare Function GetInputState Lib "user32" () As Long
Private Declare Function GetProcessHeap Lib "kernel32" () As Long
Private Declare Function HeapAlloc Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function HeapFree Lib "kernel32" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Private Declare Sub CopyMemoryWrite Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, Source As Any, ByVal Length As Long)
Private Declare Sub CopyMemoryRead Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, ByVal Source As Long, ByVal Length As Long)

Private Sub Class_Initialize()
ReDim IntegerPtr(0): ReDim LongPtr(0)
End Sub

Private Function CreateIntPtr(ByVal IntData As Integer) As Long
ReDim Preserve IntegerPtr(UBound(IntegerPtr) + 1)
Dim hHeap As Long
hHeap = GetProcessHeap()
IntegerPtr(UBound(IntegerPtr)) = HeapAlloc(hHeap, 0, 2)
If IntegerPtr(UBound(IntegerPtr)) <> 0 Then
    CopyMemoryWrite IntegerPtr(UBound(IntegerPtr)), IntData, 2
    CreateIntPtr = IntegerPtr(UBound(IntegerPtr))
Else
    CreateIntPtr = 0
    ReDim Preserve IntegerPtr(UBound(IntegerPtr) - 1)
End If
End Function

Private Function CreateLngPtr(ByVal lngData As Long) As Long
ReDim Preserve LongPtr(UBound(LongPtr) + 1)
Dim hHeap As Long
hHeap = GetProcessHeap()
LongPtr(UBound(LongPtr)) = HeapAlloc(hHeap, 0, 4)
If LongPtr(UBound(LongPtr)) <> 0 Then
    CopyMemoryWrite LongPtr(UBound(LongPtr)), lngData, 4
    CreateLngPtr = LongPtr(UBound(LongPtr))
Else
    CreateLngPtr = 0
    ReDim Preserve LongPtr(UBound(LongPtr) - 1)
End If
End Function

Public Function CreatePointer(ByVal PtrType As PtrType, ByVal Data As Long) As Long
Select Case PtrType
    Case IntPtr
        CreatePointer = CreateIntPtr(CInt(Data))
    Case LngPtr
        CreatePointer = CreateLngPtr(Data)
    Case Else
        CreatePointer = -1
End Select
End Function

Private Function DeleteIntPtr(ByVal Address As Long) As Boolean
Dim a As Integer, b As Integer
Dim tmpBuffer() As Long
On Error GoTo Error:
ReDim Preserve tmpBuffer(UBound(IntegerPtr) - 1)
For a = LBound(IntegerPtr) To UBound(IntegerPtr)
    If GetInputState() <> 0 Then
        DoEvents
    End If
    If IntegerPtr(a) <> Address Then
        tmpBuffer(a) = IntegerPtr(a)
    Else
        HeapFree GetProcessHeap(), 0, IntegerPtr(a)
    End If
Next a
ReDim IntegerPtr(UBound(IntegerPtr) - 1)
For b = LBound(tmpBuffer) To UBound(tmpBuffer)
    If GetInputState() <> 0 Then
        DoEvents
    End If
    IntegerPtr(b) = tmpBuffer(b)
Next b
DeleteIntPtr = True
Exit Function
Error:
DeleteIntPtr = False
End Function

Private Function DeleteLngPtr(ByVal Address As Long) As Boolean
Dim a As Integer, b As Integer
Dim tmpBuffer() As Long
On Error GoTo Error:
ReDim Preserve tmpBuffer(UBound(LongPtr) - 1)
For a = LBound(LongPtr) To UBound(LongPtr)
    If GetInputState() <> 0 Then
        DoEvents
    End If
    If LongPtr(a) <> Address Then
        tmpBuffer(a) = LongPtr(a)
    Else
        HeapFree GetProcessHeap(), 0, LongPtr(a)
    End If
Next a
ReDim LongPtr(UBound(LongPtr) - 1)
For b = LBound(tmpBuffer) To UBound(tmpBuffer)
    If GetInputState() <> 0 Then
        DoEvents
    End If
    LongPtr(b) = tmpBuffer(b)
Next b
DeleteLngPtr = True
Exit Function
Error:
DeleteLngPtr = False
End Function

Public Function DeletePointer(ByVal PtrType As PtrType, ByVal Address As Long) As Boolean
Select Case PtrType
    Case IntPtr
        DeletePointer = DeleteIntPtr(Address)
    Case LngPtr
        DeletePointer = DeleteLngPtr(Address)
    Case Else
        DeletePointer = False
End Select
End Function

Private Function GetIntData(ByVal Address As Long) As Integer
Dim i As Integer
For i = LBound(IntegerPtr) To UBound(IntegerPtr)
    If GetInputState() <> 0 Then
        DoEvents
    End If
    If IntegerPtr(i) = Address Then
        CopyMemoryRead GetIntData, IntegerPtr(i), 2
        Exit Function
    End If
Next i
GetIntData = 0
End Function

Private Function GetLngData(ByVal Address As Long) As Long
Dim i As Integer
For i = LBound(LongPtr) To UBound(LongPtr)
    If GetInputState() <> 0 Then
        DoEvents
    End If
    If LongPtr(i) = Address Then
        CopyMemoryRead GetLngData, LongPtr(i), 4
        Exit Function
    End If
Next i
GetLngData = 0
End Function

Public Function GetPtrData(ByVal PtrType As PtrType, ByVal Address As Long)
Select Case PtrType
    Case IntPtr
        GetPtrData = GetIntData(Address)
    Case LngPtr
        GetPtrData = GetLngData(Address)
    Case Else
        GetPtrData = "Error: Invalid pointer type!"
End Select
End Function

Private Function EditIntPtr(ByVal IntData As Integer, ByVal Address As Long) As Boolean
CopyMemoryWrite Address, IntData, 2
EditIntPtr = True
End Function

Private Function EditLngPtr(ByVal lngData As Long, ByVal Address As Long) As Boolean
CopyMemoryWrite Address, lngData, 4
EditLngPtr = True
End Function

Public Function EditPtrData(ByVal PtrType As PtrType, ByVal Data As Long, ByVal Address As Long) As Boolean
Select Case PtrType
    Case IntPtr
        EditPtrData = EditIntPtr(CInt(Data), Address)
    Case LngPtr
        EditPtrData = EditLngPtr(Data, Address)
    Case Else
        EditPtrData = False
End Select
End Function

Private Sub Class_Terminate()
Dim b As Integer, c As Integer
If UBound(IntegerPtr) <> 0 Then
    For b = LBound(IntegerPtr) + 1 To UBound(IntegerPtr)
        If GetInputState() <> 0 Then
            DoEvents
        End If
        HeapFree GetProcessHeap(), 0, IntegerPtr(b)
    Next b
End If
If UBound(LongPtr) <> 0 Then
    For c = LBound(LongPtr) + 1 To UBound(LongPtr)
        If GetInputState() <> 0 Then
            DoEvents
        End If
        HeapFree GetProcessHeap(), 0, IntegerPtr(c)
    Next c
End If
End Sub
