Attribute VB_Name = "ParseChat"
Option Explicit
Private Const IDC_USER          As String = "1001"
Private Const IDC_JOIN          As String = "1002"
Private Const IDC_LEAVE         As String = "1003"
Private Const IDC_WHISPER       As String = "1004"
Private Const IDC_TALK          As String = "1005"
Private Const IDC_BROADCAST     As String = "1006"
Private Const IDC_CHANNEL       As String = "1007"
Private Const IDC_FLAGS         As String = "1009"
Private Const IDC_WHISPERTO     As String = "1010"
Private Const IDC_INFO          As String = "1018"
Private Const IDC_ERROR         As String = "1019"
Private Const IDC_EMOTE         As String = "1023"
Private Const IDC_NULL          As String = "2000"
Private Const IDC_LOGGEDNAME    As String = "2010"

Public Sub ProcessData(ByRef mBuffer As String)
    Dim lPos As Long, pLine As String
    lPos = InStr(mBuffer, vbCrLf)                       'bnet chat lines ALMOST always terminated with CRLF
    Do While lPos > 0
        'mLines = mLines + 1                             'add to line count
        'mChars = mChars + lPos + 1                      'add to char count, including CRLF
        pLine = Left(mBuffer, lPos - 1)                 'get data up to the CRLF
        mBuffer = Mid(mBuffer, lPos + 2)                'remove the line and CRLF from buffer
        ExecuteData pLine
        lPos = InStr(mBuffer, vbCrLf)                   'check for next complete line
    Loop
    If mBuffer = "Username: " Then
    mBuffer = ""
    End If
End Sub
Private Sub ExecuteData(strLine As String)
    Dim pA() As String
    If Len(strLine) = 0 Then Exit Sub
            pA = Split(strLine, " ", 3)
            Select Case pA(0)
                Case IDC_USER                                'User already in the Room
                    pA = Split(pA(2), " ", 3)
                    ParseUser pA(0), pA(1), pA(2)
                Case IDC_JOIN                                'User Join the Room
                    pA = Split(pA(2), " ", 3)
                    ParseJoin pA(0), pA(1), pA(2)
                Case IDC_LEAVE                               'User leave the Room
                    pA = Split(pA(2), " ", 3)
                    ParseLeave pA(0)
                Case IDC_WHISPER                             'User whisper you
                    pA = Split(pA(2), " ", 3)
                    ParseWhisper pA(0), pA(1), Mid(pA(2), 2, Len(pA(2)) - 2)
                Case IDC_TALK                                'User Talk (chat text)
                    pA = Split(pA(2), " ", 3)
                    ParseTalk pA(0), pA(1), Mid(pA(2), 2, Len(pA(2)) - 2)
                Case IDC_BROADCAST:                          'Not so sure about this one
                Case IDC_CHANNEL                             'Current Channel
                    ParseChannel Mid(pA(2), 2, Len(pA(2)) - 2)
                Case IDC_FLAGS
                    pA = Split(pA(2), " ", 3)
                    ParseFlags pA(0), pA(1)
                Case IDC_WHISPERTO
                    pA = Split(pA(2), " ", 3)
                    ParseWhisperTo pA(0), pA(1), Mid(pA(2), 2, Len(pA(2)) - 2)
                Case IDC_INFO                               'Info from Battle.net
                    ParseInfo Mid(pA(2), 2, Len(pA(2)) - 2)
                Case IDC_ERROR                              'Error message from Battle.net
                    ParseError Mid(pA(2), 2, Len(pA(2)) - 2)
                Case IDC_EMOTE                              'Emote user
                    pA = Split(pA(2), " ", 3)
                    ParseEmote pA(0), pA(1), Mid(pA(2), 2, Len(pA(2)) - 3)
                'Case IDC_NULL:      ParseNull               'NULL
                Case IDC_LOGGEDNAME:                        'Your logged name
            End Select
            DoEvents
    frmMain.txtRecieve.SelStart = Len(frmMain.txtRecieve.text)
End Sub

Private Sub ParseTalk(strName As String, strFlags As String, strMessage As String)
addText "<" & strName & "> ", ID_COLOR_NAMES, strMessage & vbCrLf, vbWhite
End Sub

Private Sub ParseUser(strName As String, strFlags As String, strGame As String)
Dim IconCode As Integer
Dim game As String
IconCode = GetIconCode(strGame, strFlags)
game = GetStuff("ethbot", "ConnectionType")
If strGame = "[" & game & "]" Then frmMain.RoomList.ForeColor = vbYellow
frmMain.RoomList.ListItems.add , , strName, , IconCode
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
frmMain.RoomList.ForeColor = vbWhite
End Sub

Private Sub ParseJoin(strName As String, strFlags As String, strGame As String)
frmMain.RoomList.ListItems.add , , strName, , GetIconCode(strGame, strFlags)
addText strName & " has joined the channel using ", vbCyan, strGame & vbCrLf, vbWhite
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
End Sub

Private Sub ParseLeave(strName As String)
    Dim found As Boolean
    Dim listname As String
    Dim namelen As Integer
    Dim i As Long
    
    For i = 1 To frmMain.RoomList.ListItems.count
        If frmMain.RoomList.ListItems.item(i) = "" Then
            found = False
            Exit For
        End If
        namelen = Len(frmMain.RoomList.ListItems.item(i))
        listname = frmMain.RoomList.ListItems.item(i)
        
        
        If strName = listname Then
            found = True
            Exit For
        End If
    Next i
    If found Then frmMain.RoomList.ListItems.Remove (i)
    
addText strName & " has left the channel." & vbCrLf, vbCyan
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
End Sub

Private Sub ParseWhisper(strName As String, strFlags As String, strMessage As String)
addText strName & " Whispers you: " & strMessage & vbCrLf, vbGreen
End Sub

Private Sub ParseChannel(strChannel)
msChannelName = strChannel
addText "Joining channel " & strChannel & vbCrLf, vbYellow
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
frmMain.RoomList.ListItems.Clear
End Sub

Private Sub ParseFlags(strName As String, strFlags As String)
Dim usrIndex As Integer
    
    usrIndex = frmMain.RoomList.FindItem(strName).Index
    If statstring = "" Then statstring = "TAHC"
        With frmMain.RoomList
            .ListItems.Remove usrIndex
            .ListItems.add usrIndex, , strName, , GetIconCode(statstring, strFlags)
            '.ListItems(.ListItems.count).ListSubItems.add , , , GetLagIcon(Ping, StrFlag)
            '.ListItems(.ListItems.count).ListSubItems.add , , Ping
        End With
    If strName = username Then
        APIDeclares.OpsMode = True
    End If
End Sub

Private Sub ParseWhisperTo(strName As String, strFlags As String, strMessage As String)
addText "You Whisper to: " & strName & ": " & strMessage & vbCrLf, vbGreen
End Sub

Private Sub ParseInfo(strMessage As String)
addText strMessage & vbCrLf, ID_COLOR_INFO
End Sub

Private Sub ParseError(strMessage As String)
addText strMessage & vbCrLf, vbRed
End Sub

Private Sub ParseEmote(strName As String, strFlags As String, strMessage As String)
addText "<" & strName & " " & strMessage & ">" & vbCrLf, vbYellow
End Sub

Public Sub SendChat(ByVal sString As String)
frmMain.sckBnet.SendData sString
End Sub
