Attribute VB_Name = "ParseF"
Option Explicit
Public msChannelName As String
Public msTrigger As String
Public lSendDelay As Long
Public Sub parse0xf(PacketData As String)
Dim iEventId As Integer
Dim buf As String
If Len(PacketData) < 21 Then
    buf = PacketData
    Exit Sub
End If
PacketData = buf & PacketData
iEventId = GetDWORD(Mid(PacketData, 1, 4))
Select Case iEventId
    Case ID_USER
        ParseUser PacketData
    Case ID_JOIN
        ParseJoin Mid(PacketData, 5)
    Case ID_LEAVE
        ParseLeave Mid(PacketData, 5)
    Case ID_WHISPER
        ParseWhisper Mid(PacketData, 5)
    Case ID_TALK
        ParseTalk Mid(PacketData, 5)
    Case ID_BROADCAST
    Case ID_MOVE
        
        ParseMove Mid(PacketData, 5)
    Case ID_FULL
    Case ID_FLAGS
        ParseFlags Mid(PacketData, 5)
    Case ID_NOTEXIST
    Case ID_SEND
        ParseSend Mid(PacketData, 5)
    Case ID_RESTRICTED
    Case ID_INFO
        ParseInfo Mid(PacketData, 5)
    Case ID_ERROR
        ParseError Mid(PacketData, 5)
    Case ID_EMOTE
        ParseEmote Mid(PacketData, 5)
End Select
End Sub
'(DWORD) flags
'(DWORD) ping
'(DWORD) 0
'(DWORD) ^1
'(DWORD) ^2
'(NTSTRING) account
'(NTSTRING) text
Private Sub ParseFlags(Data As String)
Dim pos As Long
Dim lFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
lFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)

MsgBox lFlags & " " & lPing & " " & strAccount & " " & strText
End Sub
Private Sub ParseSend(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)
addText "<To: " & strAccount & "> ", ID_COLOR_NAMES, strText & vbCrLf, ID_COLOR_WHISPER
End Sub

Private Sub ParseEmote(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)

addText "<" & strAccount & " " & strText & ">" & vbCrLf, ID_COLOR_INFO
End Sub
Private Sub ParseError(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)
addText strText & vbCrLf, vbRed
End Sub
Private Sub ParseInfo(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)
addText strText & vbCrLf, ID_COLOR_BNETINFO

End Sub
Private Sub ParseMove(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)

frmMain.RoomList.ListItems.Clear
addText "Joining channel " & strText & vbCrLf, vbYellow
Dim i As Integer
Dim namelen As Integer
Dim found As Boolean
Dim listname As String
With frmChannels.Items
For i = 0 To .ListCount
        If .List(i) = "" Then
            found = False
            Exit For
        End If
        namelen = Len(.List(i))
        listname = .List(i)
        If namelen <> Len(strText) Then GoTo cont
        
        If strText = listname Then
            found = True
            Exit For
        End If
cont:
    Next i
    
If Not found Then
    .AddItem (strText)
End If
frmMain.Text1.text = strText & " " & frmMain.RoomList.ListItems.count
msChannelName = strText
username = strAccount
End With
End Sub
Private Sub ParseWhisper(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)

addText "<From: " & strAccount & "> ", ID_COLOR_NAMES, strText & vbCrLf, ID_COLOR_WHISPER
DoCommands strAccount, strText, True
End Sub
Private Sub ParseJoin(Data As String)
Dim pos As Long
Dim lFlags As Long
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
Dim Code As String
Dim IconCode As String
Dim strLvl As String
pos = 1
lFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)
If msProduct = "D2DV" Then
    strAccount = Mid(strAccount, InStr(strAccount, "*") + 1)
End If
frmMain.RoomList.ListItems.add , , strAccount, , GetIconCode(strText, lFlags)
If mbAlertLeaveJoin Then addText strAccount & " has joined the channel with a ping of " & lPing & " using ", vbCyan, strText & vbCrLf, vbWhite
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , , GetLagIcon(lPing, lFlags)
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , lPing
Select Case ReverseString(Mid(strText, 1, 4))
    Case "DRTL"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Diablo Retail" & vbCrLf & _
                                "Level: " & lvl & vbCrLf & _
                                "Class: " & getClass(Val(chrClass)) & vbCrLf & _
                                "Dots: " & dots & vbCrLf & _
                                "Strength: " & strength & vbCrLf & _
                                "Magic: " & mag & vbCrLf & _
                                "Dexterity: " & dex & vbCrLf & _
                                "Vitality: " & vit & vbCrLf & _
                                "Gold: " & gold & vbCrLf
                                
    Case "SEXP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Starcraft: Broodwar" & vbCrLf & _
                                "Wins: " & scwins & vbCrLf & _
                                "Ladder: " & scladder & " (" & scrank & ")"
    Case "W2BN"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Warcraft II: BNE" & vbCrLf & _
                                "Wins: " & wcwins & vbCrLf & _
                                "Ladder: " & wcladder
    Case "D2XP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
    Case "D2DV"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
End Select
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag & vbCrLf & "StatString: " & statstring
End Sub
Private Sub ParseUser(Data As String)
On Error GoTo ParseUser_Error
Data = Mid(Data, 5)
Static count As Integer
Dim pos As Long
Dim lFlags As Long
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
Dim Code As String
Dim strLvl As String
Dim IconCode
Dim PingCode
Dim strStat As String
Dim DataBuf As String
If Data <> "" Then

Data = DataBuf & Data
pos = 1
lFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 2)
strAccount = pA(0)
strText = pA(1)
If msProduct = "D2DV" Then
    strAccount = Mid(strAccount, InStr(strAccount, "*") + 1)
End If
'Wait (10)

PingCode = GetLagIcon(lPing, lFlags)
frmMain.RoomList.ListItems.add , , strAccount, , GetIconCode(strText, lFlags)
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , , PingCode
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
frmMain.RoomList.ForeColor = vbWhite
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).ListSubItems.add , , lPing
Select Case ReverseString(Mid(strText, 1, 4))
    Case "DRTL"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Diablo Retail" & vbCrLf & _
                                "Level: " & lvl & vbCrLf & _
                                "Class: " & getClass(Val(chrClass)) & vbCrLf & _
                                "Dots: " & dots & vbCrLf & _
                                "Strength: " & strength & vbCrLf & _
                                "Magic: " & mag & vbCrLf & _
                                "Dexterity: " & dex & vbCrLf & _
                                "Vitality: " & vit & vbCrLf & _
                                "Gold: " & gold & vbCrLf
                              
    Case "SEXP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Starcraft: Broodwar" & vbCrLf & _
                                "Wins: " & scwins & vbCrLf & _
                                "Ladder: " & scladder & " (" & scrank & ")"
                               
    Case "W2BN"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = _
                                "Warcraft II: BNE" & vbCrLf & _
                                "Wins: " & wcwins & vbCrLf & _
                                "Ladder: " & wcladder
    Case "D2XP"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
    Case "D2DV"
        frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = ParseD2Stats(strText)
End Select
frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag = frmMain.RoomList.ListItems(frmMain.RoomList.ListItems.count).Tag & vbCrLf & "StatString: " & statstring
DataBuf = ""
End If
Exit Sub
ParseUser_Error:
DataBuf = DataBuf & Data
End Sub
Private Sub ParseLeave(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim found As Boolean
Dim listname As String
Dim namelen As Integer
Dim i As Long

pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 2)
strAccount = pA(0)
If msProduct = "D2DV" Then
    strAccount = Mid(strAccount, InStr(strAccount, "*") + 1)
End If
    For i = 1 To frmMain.RoomList.ListItems.count
        If frmMain.RoomList.ListItems.item(i) = "" Then
            found = False
            Exit For
        End If
        namelen = Len(frmMain.RoomList.ListItems.item(i))
        listname = frmMain.RoomList.ListItems.item(i)
        
        
        If strAccount = listname Then
            found = True
            Exit For
        End If
    Next i
    If found Then frmMain.RoomList.ListItems.Remove (i)
    
If mbAlertLeaveJoin Then addText strAccount & " has left the channel." & vbCrLf, vbCyan
frmMain.Text1.text = msChannelName & " (" & frmMain.RoomList.ListItems.count & ")"
End Sub
Private Sub ParseTalk(Data As String)
Dim pos As Long
Dim iFlags As Integer
Dim lPing As Long
Dim pA() As String
Dim strAccount As String
Dim strText As String
pos = 1
iFlags = GetDWORD(Mid(Data, pos, 4))
pos = pos + 4
lPing = GetDWORD(Mid(Data, pos, 4))
pos = pos + 16
pA = Split(Mid(Data, pos), Chr(&H0), 3)
strAccount = pA(0)
strText = pA(1)
strText = ProfanityUnfilter(strText)
If Mid(LCase(strText), 1, 1) = "" Then
      addText "Decrypted From " & strAccount & "in Hex: ", vbYellow, hexEncrypt(strText) & vbCrLf, vbWhite
Else
addText "<" & strAccount & "> ", ID_COLOR_NAMES, strText & vbCrLf, vbWhite
'AddChat ID_COLOR_NAMES, "<", vbYellow, username, ID_COLOR_NAMES, "> ", vbWhite, strText
'CustomCommand strText, strAccount
End If
If Left(strText, 1) = msTrigger Then DoCommands strAccount, strText, False
End Sub


Public Sub Send(ByVal Data As String, Optional UnHide As Boolean)
Dim botPacket As New PacketBuffer
Dim WaitTime As Long
Dim Queue As ListBox
If Data = "" Then Data = " "
Dim strData As String
WaitTime = RequiredDelay(Len(Data))
Set Queue = frmMain.List1
'WaitTime = Len(data) * perByte
'If WaitTime > maxBytes Then WaitTime = maxBytes
lSendDelay = WaitTime
If (lSendDelay <> 0) Or (frmMain.List1.ListCount > 0) Then 'if non-zero add to queue
    
    strData = strData & Data
ElseIf frmMain.List1.ListCount = 0 Then 'since it's zero just send it
    botPacket.InsertNTString Data
    botPacket.SendPacket frmMain.sckBnet, &HE
    If UnHide = True Then addText "<" & username & "> ", vbYellow, Data & vbCrLf, vbWhite
    Exit Sub
End If

'
'If WaitTime = 0 Then
'    botPacket.InsertNTString Data
'    botPacket.SendPacket frmMain.sckBnet, &HE
'Else
'    Wait (WaitTime / 1000)
'    botPacket.InsertNTString Data
'    botPacket.SendPacket frmMain.sckBnet, &HE
'End If
If UnHide = True Then
strData = strData & Chr(1) & "1" ' a null follow by "1" to show
End If
Queue.AddItem strData
Call UpdateQueue
End Sub

Public Sub UpdateQueue()
frmMain.StatusBar1.Panels(2).text = "Queue [" & frmMain.List1.ListCount & "]"
End Sub
